
#include "heartbeat.lua"

function init()

	names2 = {"Shakin Hands","Clumsy","Rattle","Skunk","Dancemachine","Beatbox","Bubbles","Fisheye","Horse","Machine","The Whale","Bones","Brainless","Bucky","Bottleneck","Whiskey","The Injury","Barefoot","Genious","Collateral","Stampeede"}
	names3 = {"Waterless","Firestarter","Willis","O'Neil","Harrisson","Barnes","Jones","Walker","Birds","Tanker","Hersh","Walsh","Malone","O'Leary","Pankerton","Parson","Phillips","Smith"}	
	namesFemale = {"Jane","Diane","Samantha","Audrey","Lela","Dora","Hillary","Luise","Andrea"}
	namesMale = {"Jim","Joe","Andrew","Johnny","Dave","Charlie","Mike","Micky","Bernard","Claire"}

    Head = FindBody("Head")
    HeadBloodCapacity = GetBodyMass(Head)
    HeadBloodLevel = HeadBloodCapacity * 20
    StartingBleed = HeadBloodCapacity
    MaxBloodCapacity = GetBodyMass(Head)
    bleed = true

    Torso = FindBody("Torso")
    TorsoBloodCapacity = GetBodyMass(Torso)
    TorsoBloodLevel = TorsoBloodCapacity * 20
    StartingBleed1 = TorsoBloodCapacity
    MaxBloodCapacity1 = GetBodyMass(Torso)
    bleed1 = true

    LARM = FindBody("LARM")
    LARMBloodCapacity = GetBodyMass(LARM)
    LARMBloodLevel = LARMBloodCapacity * 20
    StartingBleed2 = LARMBloodCapacity
    MaxBloodCapacity2 = GetBodyMass(LARM)

    bleed2 = true

    LLARM = FindBody("LLARM")
    LLARMBloodCapacity = GetBodyMass(LLARM)
    LLARMBloodLevel = LLARMBloodCapacity * 20
    StartingBleed3 = LLARMBloodCapacity
    MaxBloodCapacity3 = GetBodyMass(LLARM)
    bleed3 = true

    RARM = FindBody("RARM")
    RARMBloodCapacity = GetBodyMass(RARM)
    RARMBloodLevel = RARMBloodCapacity * 20
    StartingBleed4 = RARMBloodCapacity
    MaxBloodCapacity4 = GetBodyMass(RARM)
    bleed4 = true

    RRARM = FindBody("RRARM")
    RRARMBloodCapacity = GetBodyMass(RRARM)
    RRARMBloodLevel = RRARMBloodCapacity * 20
    StartingBleed5 = RRARMBloodCapacity
    MaxBloodCapacity5 = GetBodyMass(RRARM)
    bleed5 = true

    LLEG = FindBody("LLEG")
    LLEGBloodCapacity = GetBodyMass(LLEG)
    LLEGBloodLevel = LLEGBloodCapacity * 20
    StartingBleed6 = LLEGBloodCapacity
    MaxBloodCapacity6 = GetBodyMass(LLEG)
    bleed6 = true

    LLLEG = FindBody("LLLEG")
    LLLEGBloodCapacity = GetBodyMass(LLLEG)
    LLLEGBloodLevel = LLLEGBloodCapacity * 20
    StartingBleed7 = LLLEGBloodCapacity
    MaxBloodCapacity7 = GetBodyMass(LLLEG)
    bleed7 = true

    RLEG = FindBody("RLEG")
    RLEGBloodCapacity = GetBodyMass(RLEG)
    RLEGBloodLevel = RLEGBloodCapacity * 20
    StartingBleed8 = RLEGBloodCapacity
    MaxBloodCapacity8 = GetBodyMass(RLEG)
    bleed8 = true

    RRLEG = FindBody("RRLEG")
    RRLEGBloodCapacity = GetBodyMass(RRLEG)
    RRLEGBloodLevel = RRLEGBloodCapacity * 20
    StartingBleed9 = RRLEGBloodCapacity
    MaxBloodCapacity9 = GetBodyMass(RRLEG)
    bleed9 = true

    antibleed = 15 -- only affects smoke speed
    extremeantibleed = 500 -- affects extreme bleed which is caused by total organ failure, reduce for blood to explode more
    regularantibleed = 30 -- affects cureable bleeds, reduce to have more blood in general
    limbantibleed = 30 -- affects bleeding of limbs, decrease to have more blood from arms and legs
    MinBloodValue = 100 -- minimum allowed blood value for human to stay alive

    LimbBleedSpeed = 0.1

    bloodgrav = -20
    blooddrag = 0
    standup = 4
    startupspeed = Vec(0, standup, 0)
    upspeed = Vec(0, standup, 0)
    downspeed = Vec(0, -standup, 0)
    alive = true
    enabled = true
    startingweightb = -0.1
    weightb = startingweightb
    oppositeweightb = weightb * -1
    startweightb = weightb
    switched = true
    attacktim = 0
    attackslash = 1
    attackforce = weightb * 100
    att1 = false
    att2 = false
    walk = true
    walktimer = 0
    s = 1
    distToCheckpoint = 0
    weight = 11
    Shock = 235
    range = 10
    PrioritizeCiv = false
    infection = 0
    InfectRange = 2
    startblood = 1000000
    xray = false
    damage = 0.1
    melle = 2
    punchsnd = LoadSound("MOD/gorescript/snd/zombie/punch.ogg")
    miss = LoadSound("MOD/gorescript/snd/zombie/miss.ogg")
    tripped = false
    trippingspeed = 7
    starttrippingspeed = trippingspeed
    triptimer = 0
    MaxTimeSpentAsleep = 3
    neck = FindJoint("Neck")
    firedetectrange = 10
    extinguishrange = 4
    saferange = 3
    walkspeed = 0.5
    swalkspeed = walkspeed
    foamer = FindShape("particleinator")
    extinguishtim = 0
    following = false
	
	if HasTag(Torso,"characterName") then
		name = GetTagValue(Torso,"characterName")
	elseif HasTag(Torso,"gender") and GetTagValue(Torso,"gender") == "male" then
		name = string.format("%s %s",namesMale[math.random(1,#namesMale)],names3[math.random(1,#names3)])
	else
		name = string.format("%s %s",namesFemale[math.random(1,#namesFemale)],names3[math.random(1,#names3)])
	end
	
    if HasTag(Torso, "FireMan") then
        Firefighter = true
        walkspeed = 0.35
		if HasTag(Torso,"characterName") then
			name = GetTagValue(Torso,"characterName")
		elseif HasTag(Torso,"gender") and GetTagValue(Torso,"gender") == "male" then
			name = string.format("%s '%s' %s",namesMale[math.random(1,#namesMale)],names2[math.random(1,#names2)],names3[math.random(1,#names3)])
		else
			name = string.format("%s '%s' %s",namesFemale[math.random(1,#namesFemale)],names2[math.random(1,#names2)],names3[math.random(1,#names3)])
		end
    end
    SetTag(Head, "interact", "Follow me!")
    alarmtrig = FindTrigger("alarm")
    alarmtim = 0
    alarmlight = FindLight("real")
    alarmphone = FindBody("funnyalarm")
    alarmphonelight = FindShape("agario")
    x = 0
    flash = false
    lungintegrity = 100
    oxygen = 100
    if Firefighter then
        oxygen = 1000
    end
    suffocating = false
    enemy = GetBodyTransform(Head)
    pressedtim = 0
    playerinteraction = false
    jump = FindShape("jump")
    jumpcooldown = 0
    jd = 0
    alarmtranvel = 0
    cycledthrucode = false
    TotalBleedValue = 0
    deathtim = 0
    maxdeathtim = 1
    disttofiredeath = 100
    Boilers = FindBodies("Boiler", true)
    owo = FindShapes("blushingemoji", true)
    suffocationrange = 0.3
    enabled = false
    onmorphine = 0
	
	TotalBloodValue = 0
	MaximumBloodValue = 0
    onmorphine = 0
    onadrenaline = 0
    onmedkit = 0
    discharge = LoadSound("MOD/snd/defdischarge.ogg")
    ambulances = FindBodies("ambulance", true)
    CET = 0
    extractrange = 2
    extracttime = 5
end

function tick(dt)
    if not Firefighter and alive then
    for i=1,#ambulances do
        TorsoPos = GetBodyTransform(Torso)
        ambulance = ambulances[i]
        ambtrans = GetBodyTransform(ambulance)
        DistToAmb = VecLength(VecSub(TorsoPos.pos, ambtrans.pos))
        if DistToAmb < extractrange then
            CET = CET + dt
            DrawBodyOutline(Head, 1, 1, 1, CET/extracttime)
            DrawBodyOutline(Torso, 1, 1, 1, CET/extracttime)
            DrawBodyOutline(LLARM, 1, 1, 1, CET/extracttime)
            DrawBodyOutline(RRARM, 1, 1, 1, CET/extracttime)
            DrawBodyOutline(LLLEG, 1, 1, 1, CET/extracttime)
            DrawBodyOutline(RRLEG, 1, 1, 1, CET/extracttime)
            DrawBodyOutline(LARM, 1, 1, 1, CET/extracttime)
            DrawBodyOutline(RARM, 1, 1, 1, CET/extracttime)
            DrawBodyOutline(LLEG, 1, 1, 1, CET/extracttime)
            DrawBodyOutline(RLEG, 1, 1, 1, CET/extracttime)
            if CET > extracttime then
                Delete(Head)
                Delete(Torso)
                Delete(LLARM)
                Delete(RRARM)
                Delete(LARM)
                Delete(RARM)
                Delete(LLLEG)
                Delete(RRLEG)
                Delete(LLEG)
                Delete(RLEG)
            end
        else
            CET = 0
        end
    end
end

	if TotalBloodValue > 0 and MaximumBloodValue == 0 then
		-- initialize the max health
		MaximumBloodValue = TotalBloodValue
	end

	SetTag(Torso,"Stats_MaxHealth",MaximumBloodValue)
	SetTag(Torso,"Stats_Health",TotalBloodValue)
	SetTag(Torso,"Stats_Oxygen",oxygen)
	SetTag(Torso,"Stats_Name",name)

    playerlookpos = GetAimPos()

    HeadPos = GetBodyTransform(Head)

    disttoplayerlookposfromragdoll = VecLength(VecSub(playerlookpos, HeadPos.pos))
    if disttoplayerlookposfromragdoll < 1 then
        inrange = true
    else
        inrange = false
    end

    for i = 1, #owo do
        uwu = owo[i]
        OwO = GetShapeWorldTransform(uwu).pos
        disttoUwU = VecLength(VecSub(HeadPos.pos, OwO))
        if disttoUwU < suffocationrange then
            oxygen = oxygen - 1
            if not alive and deathtim < 1 then
                if not playerinteraction and not aboto then
                    causeofdeath = "why did you try this..."
                end
            end
        end
    end

    if disttofiredeath < 1 and not alive and deathtim < maxdeathtim then
        causeofdeath = "severe burns"
    end
    if cycledthrucode then
        TotalBleedValue = Bleed + Bleed1 + Bleed2 + Bleed3 + Bleed4 + Bleed5 + Bleed6 + Bleed7 + Bleed8
    end
    if not alive then
        deathtim = deathtim + dt
    end
    if following then
    end

    if Firefighter then
        jumptrans = GetShapeWorldTransform(jump)
        jhit, jd = QueryRaycast(jumptrans.pos, Vec(0, -1, 0), 13)
    end
    jumpcooldown = jumpcooldown + dt
    if
        Firefighter and jd < 1.6 and jumpcooldown > 2 and alarmtranvel < 1 and following and alive and not playerinstead and
            not tripped
     then
        if not IsBodyBroken(LLLEG) and not IsBodyBroken(LLEG) and not IsBodyBroken(RRLEG) and not IsBodyBroken(RLEG) then
            SetBodyVelocity(LLLEG, Vec(0, 20, 0))
        end
        SetBodyVelocity(RRLEG, Vec(0, 20, 0))
        SetBodyVelocity(Head, Vec(0, 20, 0))
        jumpcooldown = 0
    end
    HeadVolocity = GetBodyVelocity(Torso)
    HeadVel = VecLength(HeadVolocity)
    cycledd = false
    alarmpos = GetBodyTransform(alarmphone)
    alarmvel = GetBodyVelocity(alarmphone)
    alarmtranvel = VecLength(alarmvel)
    local firehit2, firepos2 = QueryClosestFire(HeadPos.pos, firedetectrange)
    disttothreat = VecLength(VecSub(firepos2, HeadPos.pos))

    if alive then
        if lungintegrity < 0 or oxygen < 0 then
            alive = false
            if deathtim < maxdeathtim then
                causeofdeath = "smoke inhalation"
            end
        end
        if oxygen < 70 then
            lowoxygen = true
        else
            lowoxygen = false
        end
		
        if disttothreat < 6 and suffocating then
            oxygen = oxygen - QueryAabbFireCount(Vec(HeadPos.pos[1] -3,HeadPos.pos[2] -3,HeadPos.pos[3] -3), Vec(HeadPos.pos[1] +3,HeadPos.pos[2] + 1,HeadPos.pos[3] +3))/300
            if not Firefighter then
                lungintegrity = lungintegrity - QueryAabbFireCount(Vec(HeadPos.pos[1] -3,HeadPos.pos[2] -3,HeadPos.pos[3] -3), Vec(HeadPos.pos[1] +3,HeadPos.pos[2] + 1,HeadPos.pos[3] +3))/600
            end
        else
            if oxygen < lungintegrity then
                oxygen = oxygen + 0.2
            end
        end
    end

    local hit, d = QueryRaycast(Vec(HeadPos.pos[1], HeadPos.pos[2] + 1, HeadPos.pos[3]), Vec(0, 1, 0), 3)
    if hit then
        suffocating = true
    else
        suffocating = false
    end
    if not conditioncritical or Morphine then
        if flash and Firefighter and alive and not lowoxygen then
            SetBodyVelocity(LLLEG, Vec(0, 10, 0))
            SetBodyVelocity(RRLEG, Vec(0, 10, 0))
        end
    end
    if flash then
        x = x + 0.2
        lightamount = math.sin(x)
        SetShapeEmissiveScale(alarmphonelight, lightamount)
        SetLightIntensity(alarmlight, lightamount)
    else
        SetShapeEmissiveScale(alarmphonelight, 0)
        SetLightIntensity(alarmlight, 0)
    end
    if alarmtranvel < 0.4 then
        alarmtim = alarmtim + dt
        if alarmtim > 5 then
            flash = true
            SetTriggerTransform(alarmtrig, alarmpos)
        end
    else
        SetTriggerTransform(alarmtrig, Transform(Vec(0, -1000, 0), Vec(0, 0, 0)))
        alarmtim = 0
        flash = false
    end
    if GetPlayerInteractBody() == Head and InputPressed("interact") and not following then
        cycledd = true
        following = true
        SetTag(Head, "interact", "Stop following me!")
        walkspeed = swalkspeed / 1.5
    end
    if GetPlayerInteractBody() == Head and InputPressed("interact") and following and not cycledd then
        cycledd = true
        following = false
        SetTag(Head, "interact", "Follow me!")
        walkspeed = swalkspeed
    end

    if conditioncritical and not Morphine then
        SetTag(Torso, "critical")
    end
    if not alive then
        SetTag(Torso, "Dead")
    else
        RemoveTag(Torso, "Dead")
    end
    foamtrans = GetShapeWorldTransform(foamer)
    distToPlayer = VecLength(VecSub(HeadPos.pos, GetPlayerTransform().pos))
    local firehit, firepos = QueryClosestFire(HeadPos.pos, firedetectrange)
    disttofiredeath = VecLength(VecSub(firepos, HeadPos.pos))
    if following then
    end
    if Firefighter then
        disttofire = VecLength(VecSub(firepos, HeadPos.pos))
    else
        disttofire = 1000000
    end
    if disttofire < firedetectrange or following then
        fireing = true
    else
        fireing = false
    end
    if disttofire < firedetectrange or following then
        if Firefighter then
            enemy = Transform(firepos, Vec(0, 0, 0))
        end
        if disttofire > firedetectrange or not Firefighter then
            enemy = GetPlayerTransform()
            enemy.pos[2] = enemy.pos[2] + 3
            playerfol = true
            if distToPlayer < firedetectrange / 3 then
                playerinstead = true
            else
                playerinstead = false
            end
        else
            playerfol = false
            playerinstead = false
        end
        if not conditioncritical or Morphine then
            if alive and disttofire < extinguishrange or playerinstead then
                weightb = 0
                if not playerfol then
                    Foam()
                end
                if alive and not playerfol and not conditioncritical or Morphine and not lowoxygen then
                    extinguishtim = extinguishtim + dt
                    if extinguishtim > 0.6 then
                        removedCount = RemoveAabbFires(firepos, firepos)
                        extinguishtim = 0
                    end
                end
            else
                weightb = startweightb
            end
        end
        if disttofire < saferange then
            weightb = oppositeweightb
        end
        firedetected = true
    else
        firedetected = false
        weightb = startweightb
    end

    if IsJointBroken(neck) and alive then
        alive = false
        if deathtim < maxdeathtim then
            causeofdeath = "decapitation"
        end
    end
    if not Morphine then
        if conditioncritical or lowoxygen and not HasTag(Torso, "Zombie") then
            tripped = true
        end
    end
    if not Morphine then
        if conditioncritical or lowoxygen and HasTag(Torso, "Zombie") then
            Shock = 240
        end
    end
    if not conditioncritical or Morphine then
        if tripped and HeadVel < trippingspeed and not lowoxygen then
            triptimer = triptimer + dt
            if alive then
                tripd = true
            end
        end
        if triptimer > MaxTimeSpentAsleep then
            tripped = false
            triptimer = 0
            tripd = false
        end
    end
    if not alive then
        if tripd then
            deathbytripping = true
        end
    end
    if HeadVel > trippingspeed then
        tripped = true
    end
    cycled1 = false
    if InputPressed("x") and not xray and not cycled1 then
        xray = true
        cycled1 = true
    end
    if InputPressed("x") and xray and not cycled1 then
        xray = false
        cycled1 = true
    end
    if not alive then
        RemoveTag(Torso, "Civillian")
        RemoveTag(Torso, "Zombie")
    end
    if IsBodyBroken(Torso) then
        Shock = Shock * 1.1
    end
    if distToCheckpoint < 4 or distToPlayer < 4 then
        close = true
    else
        close = false
    end
    if xray and disttoplayerlookposfromragdoll < 5 then
        if HasTag(Torso, "Civillian") and not conditioncritical then
            DrawBodyOutline(Head, 0, 1, 0, 1)
            DrawBodyOutline(Torso, 0, 1, 0, 1)
            DrawBodyOutline(LLARM, 0, 1, 0, 1)
            DrawBodyOutline(RRARM, 0, 1, 0, 1)
            DrawBodyOutline(LLLEG, 0, 1, 0, 1)
            DrawBodyOutline(RRLEG, 0, 1, 0, 1)
            DrawBodyOutline(LARM, 0, 1, 0, 1)
            DrawBodyOutline(RARM, 0, 1, 0, 1)
            DrawBodyOutline(LLEG, 0, 1, 0, 1)
            DrawBodyOutline(RLEG, 0, 1, 0, 1)
        else
            DrawBodyOutline(Head, 0, 1, 0, 1)
            DrawBodyOutline(Torso, 0, 1, 0, 1)
            DrawBodyOutline(LLARM, 0, 1, 0, 1)
            DrawBodyOutline(RRARM, 0, 1, 0, 1)
            DrawBodyOutline(LLLEG, 0, 1, 0, 1)
            DrawBodyOutline(RRLEG, 0, 1, 0, 1)
            DrawBodyOutline(LARM, 0, 1, 0, 1)
            DrawBodyOutline(RARM, 0, 1, 0, 1)
            DrawBodyOutline(LLEG, 0, 1, 0, 1)
            DrawBodyOutline(RLEG, 0, 1, 0, 1)
        end
        if not alive then
            DrawBodyOutline(Head, 1, 0, 0, 1)
            DrawBodyOutline(Torso, 1, 0, 0, 1)
            DrawBodyOutline(LLARM, 1, 0, 0, 1)
            DrawBodyOutline(RRARM, 1, 0, 0, 1)
            DrawBodyOutline(LLLEG, 1, 0, 0, 1)
            DrawBodyOutline(RRLEG, 1, 0, 0, 1)
            DrawBodyOutline(LARM, 1, 0, 0, 1)
            DrawBodyOutline(RARM, 1, 0, 0, 1)
            DrawBodyOutline(LLEG, 1, 0, 0, 1)
            DrawBodyOutline(RLEG, 1, 0, 0, 1)
        end
        if conditioncritical then
             DrawBodyOutline(Head, 1, 1, 0, 1)
            DrawBodyOutline(Torso, 1, 1, 0, 1)
            DrawBodyOutline(LLARM, 1, 1, 0, 1)
            DrawBodyOutline(RRARM, 1, 1, 0, 1)
            DrawBodyOutline(LLLEG, 1, 1, 0, 1)
            DrawBodyOutline(RRLEG, 1, 1, 0, 1)
            DrawBodyOutline(LARM, 1, 1, 0, 1)
            DrawBodyOutline(RARM, 1, 1, 0, 1)
            DrawBodyOutline(LLEG, 1, 1, 0, 1)
            DrawBodyOutline(RLEG, 1, 1, 0, 1)
        end
    end

    if IsBodyBroken(LARM) or IsBodyBroken(LLARM) then
        Leftbroke = true
    end

    if IsBodyBroken(RARM) or IsBodyBroken(RRARM) then
        rightbroke = true
    end

    if canSeePlayer() and HasTag(Torso, "Zombie") then
        agro = true
    end

    if infection > 100 then
        SetTag(Torso, "Zombie")
    end
    PrioritizeCiv = false
    if HasTag(Torso, "Zombie") then
        if distToPlayer < melle then
            Hit = true
        else
            Hit = false
        end
        infection = 100
        RemoveTag(Torso, "Civillian")
        Civillians = FindBodies("Torso", true)
        for i = 1, #Civillians do
            Civillian = Civillians[i]
            if HasTag(Civillian, "Civillian") then
                CivPos = GetBodyTransform(Civillian)
                Disttociv = VecLength(VecSub(CivPos.pos, HeadPos.pos))
                if Disttociv < range and Disttociv < distToPlayer then
                    CivPos = GetBodyTransform(Civillian)
                    enemy = CivPos
                    PrioritizeCiv = true
                    close = true
                end
            end
        end
    end

    if HasTag(Torso, "Civillian") then
        Zombies = FindBodies("Zombie", true)
        for i = 1, #Zombies do
            Zombie = Zombies[i]
            ZombPos = GetBodyTransform(Zombie)
            DistToZombie = VecLength(VecSub(ZombPos.pos, HeadPos.pos))
            if DistToZombie < InfectRange then
                infection = infection + 0.1
            end
        end
    end

    if PrioritizeCiv then
        agro = true
    end

    chckpnts = FindLocations("patrol")
    if s > #chckpnts then
        s = 1
    end
    if #FindLocations("patrol") > 0 and not Firefighter or fireing or alive and following then
        for i = 1, #chckpnts do
            checkpoint = chckpnts[s]
            checkpointposition = GetLocationTransform(checkpoint)
            distToCheckpoint = VecLength(VecSub(HeadPos.pos, checkpointposition.pos))
            if not agro then
                if Firefighter and not firedetected then
                    if #chckpnts > 0 then
                        enemy = checkpointposition
                    end
                end
                if not Firefighter and not following then
                    enemy = checkpointposition
                end
            else
                --enemy = checkpointposition
                if not PrioritizeCiv then
                    enemy = GetPlayerTransform()
                end
            end
            if distToCheckpoint < 1 then
                s = s + 1
            end
            if following and not Firefighter then
                enemy = GetPlayerTransform()
            end
        end

        if alive and not tripped then
            walktimer = walktimer + dt

            if walktimer > walkspeed / 2 and not walked1 then
                local ppos = enemy.pos
                local bmi, bma = GetBodyBounds(LLLEG)
                local bc = VecLerp(bmi, bma, 0.5)
                local ppos = enemy.pos
                local dir = VecSub(bc, ppos)
                local dist = VecLength(dir)
                dir = VecScale(dir, 1.0 / dist)
                local add = VecScale(dir, weightb * 150)
                local vel = GetBodyVelocity(LLLEG)
                totvel = VecAdd(vel, add)
                if
                    not IsBodyBroken(LLLEG) and not IsBodyBroken(LLEG) and not IsBodyBroken(RRLEG) and
                        not IsBodyBroken(RLEG)
                 then
                    SetBodyVelocity(LLLEG, totvel)
                end
                walked1 = true
                walked2 = false
            end

            if walktimer > walkspeed and not walked2 then
                local ppos = enemy.pos
                local bmi, bma = GetBodyBounds(RRLEG)
                local bc = VecLerp(bmi, bma, 0.5)
                local ppos = enemy.pos
                local dir = VecSub(bc, ppos)
                local dist = VecLength(dir)
                dir = VecScale(dir, 1.0 / dist)
                local add = VecScale(dir, weightb * 150)
                local vel = GetBodyVelocity(RRLEG)
                totvel = VecAdd(vel, add)
                if
                    not IsBodyBroken(LLLEG) and not IsBodyBroken(LLEG) and not IsBodyBroken(RRLEG) and
                        not IsBodyBroken(RLEG)
                 then
                    SetBodyVelocity(RRLEG, totvel)
                end
                walked2 = true
                walked1 = false
                walktimer = 0
            end

            local target = enemy.pos
            local approachspeed = 5
            local smoothspeed = 5

            local ttr = GetBodyTransform(Torso)
            local currentavel = GetBodyAngularVelocity(Torso)

            local targetrot = QuatLookAt(ttr.pos, target)
            local ltargetrot = TransformToLocalTransform(ttr, Transform(Vec(), targetrot))
            local targetavel = VecScale(Vec(GetQuatEuler(ltargetrot.rot)), approachspeed)
            local diff = VecSub(targetavel, currentavel)
            diff[1] = math.max(math.min(diff[1], smoothspeed), -smoothspeed)
            diff[2] = math.max(math.min(diff[2], smoothspeed), -smoothspeed)
            diff[3] = math.max(math.min(diff[3], smoothspeed), -smoothspeed)
            SetBodyAngularVelocity(Torso, VecAdd(currentavel, diff))
        end

        if alive and walk then
            if agro or HasTag(Torso, "Zombie") then
                trippingspeed = 10
                attacktim = attacktim + dt
                local ppos = enemy.pos
                local bmi, bma = GetBodyBounds(LLARM)
                local bc = VecLerp(bmi, bma, 0.5)
                local ppos = enemy.pos
                local dir = VecSub(bc, ppos)
                local dist = VecLength(dir)
                dir = VecScale(dir, 1.0 / dist)
                weightb = startweightb

                if attacktim > attackslash then
                    if not att1 then
                        weightb = attackforce
                        if not Leftbroke then
                            local add = VecScale(dir, weightb)
                            local vel = GetBodyVelocity(LLARM)
                            vel = VecAdd(vel, add)
                            SetBodyVelocity(LLARM, vel)
                            if Hit then
                                SetPlayerHealth(GetPlayerHealth() - damage)
                                PlaySound(punchsnd, HeadPos.pos)
                            else
                                --PlaySound(miss, HeadPos.pos)
                            end
                            att1 = true
                            att2 = false
                        end
                    end

                    if attacktim > attackslash * 2 then
                        if not att2 then
                            weightb = attackforce
                            attacktim = 0
                            if not rightbroke then
                                local add = VecScale(dir, weightb)
                                local vel = GetBodyVelocity(LLARM)
                                vel = VecAdd(vel, add)
                                SetBodyVelocity(RRARM, vel)
                                att2 = true
                                att1 = false
                                if Hit then
                                    SetPlayerHealth(GetPlayerHealth() - damage)
                                    PlaySound(punchsnd, HeadPos.pos)
                                else
                                    --PlaySound(miss, HeadPos.pos)
                                end
                            end
                        end
                    end
                end
                weightb = startweightb
                local bmi, bma = GetBodyBounds(RRARM)
                local bc = VecLerp(bmi, bma, 0.5)
                local ppos = enemy.pos
                local dir = VecSub(bc, ppos)
                local dist = VecLength(dir)
                dir = VecScale(dir, 1.0 / dist)
                local add = VecScale(dir, weightb)
                local vel = GetBodyVelocity(RRARM)
                vel = VecAdd(vel, add)
                if not rightbroke then
                    SetBodyVelocity(RRARM, vel)
                end
                if not Leftbroke then
                    SetBodyVelocity(LLARM, vel)
                end
            end
        end

        gunTrans = GetBodyTransform(Head)
        gunPos = gunTrans.pos
        direction = TransformToParentVec(gunTrans, Vec(0, -1, 0))
        shootPos = VecAdd(gunPos, VecScale(direction, 0.2))

        if IsBodyBroken(Head) and alive then
            alive = false
            if deathtim < maxdeathtim then
                causeofdeath = "brain damage"
            end
        end
    end

    drawtext = false

    HeadBloodCapacity = GetBodyMass(Head)
    Bleed = StartingBleed - HeadBloodCapacity
    HeadPos = GetBodyTransform(Head)

    TorsoBloodCapacity = GetBodyMass(Torso)
    Bleed1 = StartingBleed1 - TorsoBloodCapacity
    TorsoPos = GetBodyTransform(Torso)

    LARMBloodCapacity = GetBodyMass(LARM)
    Bleed2 = StartingBleed2 - LARMBloodCapacity
    LARMPos = GetBodyTransform(LARM)

    LLARMBloodCapacity = GetBodyMass(LLARM)
    Bleed3 = StartingBleed3 - LLARMBloodCapacity
    LLARMPos = GetBodyTransform(LLARM)

    RARMBloodCapacity = GetBodyMass(RARM)
    Bleed4 = StartingBleed4 - RARMBloodCapacity
    RARMPos = GetBodyTransform(RARM)

    RRARMBloodCapacity = GetBodyMass(RRARM)
    Bleed5 = StartingBleed5 - RRARMBloodCapacity
    RRARMPos = GetBodyTransform(RRARM)

    LLEGBloodCapacity = GetBodyMass(LLEG)
    Bleed6 = StartingBleed6 - LLEGBloodCapacity
    LLEGPos = GetBodyTransform(LLEG)

    LLLEGBloodCapacity = GetBodyMass(LLLEG)
    Bleed7 = StartingBleed7 - LLLEGBloodCapacity
    LLLEGPos = GetBodyTransform(LLLEG)

    RLEGBloodCapacity = GetBodyMass(RLEG)
    Bleed8 = StartingBleed8 - RLEGBloodCapacity
    RLEGPos = GetBodyTransform(RLEG)

    RRLEGBloodCapacity = GetBodyMass(RRLEG)
    Bleed9 = StartingBleed9 - RRLEGBloodCapacity
    RRLEGPos = GetBodyTransform(RRLEG)

    if Medkit or Adrenaline then
        if Adrenaline then
            MULTVAL = 1.4
        end
        if Medkit then
            MULTVAL = 0.02
        end
        Bleed = Bleed * MULTVAL
        Bleed1 = Bleed1 * MULTVAL
        Bleed2 = Bleed2 * MULTVAL
        Bleed3 = Bleed3 * MULTVAL
        Bleed4 = Bleed4 * MULTVAL
        Bleed5 = Bleed5 * MULTVAL
        Bleed6 = Bleed6 * MULTVAL
        Bleed7 = Bleed7 * MULTVAL
        Bleed8 = Bleed8 * MULTVAL
        Bleed9 = Bleed9 * MULTVAL
    end

    --HEAD HEAD HEAD HEAD HEAD HEAD LLEGHEAD HEAD HEAD HEAD
    if bleed then
        if IsBodyBroken(Head) then
            for i = 1, 9 do
                thingz = FindJoints("eye")
                for i = 1, #thingz do
                    thinz = thingz[i]
                    Delete(thinz)
                end
            end

            for i = 1, Bleed / 2 do
                smoke()
            end
        end
    end

    if bleed then
        if HeadBloodCapacity < MaxBloodCapacity then
            Bleed = Bleed * 6

            for i = 1, Bleed / 6 do
                smoke()
            end
        end

        HeadBloodLevel = HeadBloodLevel - Bleed / 2
    end

    if HeadBloodLevel <= 0 then
        bleed = false
        HeadBloodLevel = 0
    end

    --TORSO TORSO TORSO TORSO TORSO TORSO TORSO

    if bleed1 then
        if IsBodyBroken(Torso) then
            for i = 1, Bleed1 / regularantibleed do
                smoke1()
            end
        end
    end

    if bleed1 then
        if TorsoBloodCapacity < MaxBloodCapacity1 / 2 then
            Bleed1 = Bleed1 * 6

            for i = 1, 9 do
                things = FindBodies("gut", true)
                for i = 1, #things do
                    thing = things[i]
                    SetBodyDynamic(thing, true)
                end
            end
            for i = 1, Bleed1 / extremeantibleed do
                smoke1()
            end
        end

        TorsoBloodLevel = TorsoBloodLevel - Bleed1
    end

    if TorsoBloodLevel <= 0 then
        bleed1 = false
        TorsoBloodLevel = 0
    end

    -- ARMARMARMARMAMRAMRMARMAMRAMRMARMAMRAMMARMAMAMRMARMMRMARMRMAMRMAR

    if bleed2 then
        if LARMBloodCapacity < MaxBloodCapacity2 / 3 then
            Bleed2 = Bleed2 * 6

            for i = 1, Bleed2 / extremeantibleed do
                smoke2()
            end
        end

        if IsBodyBroken(LARM) then
            for i = 1, Bleed2 / limbantibleed do
                smoke2()
            end
        end
    end

    if bleed2 then
        LARMBloodLevel = LARMBloodLevel - Bleed2 * LimbBleedSpeed
    end

    if LARMBloodLevel <= 0 then
        bleed2 = false
        LARMBloodLevel = 0
    end

    --aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa

    if bleed3 then
        if LLARMBloodCapacity < MaxBloodCapacity3 / 3 then
            Bleed3 = Bleed3 * 6

            for i = 1, Bleed3 / extremeantibleed do
                smoke3()
            end
        end

        if IsBodyBroken(LLARM) then
            for i = 1, Bleed3 / limbantibleed do
                smoke3()
            end
        end
    end

    if bleed3 then
        LLARMBloodLevel = LLARMBloodLevel - Bleed3 * LimbBleedSpeed
    end

    if LLARMBloodLevel <= 0 then
        bleed3 = false
        LLARMBloodLevel = 0
    end

    --aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa

    if bleed4 then
        if RARMBloodCapacity < MaxBloodCapacity4 / 3 then
            Bleed4 = Bleed4 * 6

            for i = 1, Bleed4 / extremeantibleed do
                smoke4()
            end
        end

        if IsBodyBroken(RARM) then
            for i = 1, Bleed4 / limbantibleed do
                smoke4()
            end
        end
    end

    if bleed4 then
        RARMBloodLevel = RARMBloodLevel - Bleed4 * LimbBleedSpeed
    end

    if RARMBloodLevel <= 0 then
        bleed4 = false
        RARMBloodLevel = 0
    end

    --aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa

    if bleed5 then
        if RRARMBloodCapacity < MaxBloodCapacity5 / 3 then
            Bleed5 = Bleed5 * 6

            for i = 1, Bleed5 / extremeantibleed do
                smoke5()
            end
        end

        if IsBodyBroken(RRARM) then
            for i = 1, Bleed5 / limbantibleed do
                smoke5()
            end
        end
    end

    if bleed5 then
        RRARMBloodLevel = RRARMBloodLevel - Bleed5 * LimbBleedSpeed
    end

    if RRARMBloodLevel <= 0 then
        bleed5 = false
        RRARMBloodLevel = 0
    end

    --LEGLEGLEGLELGLELGLGLELGLEGLLGLEGLELGLEGLELGLEGLEGLELGELLEGLEGLLEGLEGLGELGELGLEGLELGELGLEGLEGLLEGLEGLLEGLELGLEGLELGLEGLLEGLELGELGELG

    if bleed6 then
        if LLEGBloodCapacity < MaxBloodCapacity6 / 3 then
            Bleed6 = Bleed6 * 6

            for i = 1, Bleed6 / extremeantibleed do
                smoke6()
            end
        end

        if IsBodyBroken(LLEG) then
            for i = 1, Bleed6 / limbantibleed do
                smoke6()
            end
        end
    end

    if bleed6 then
        LLEGBloodLevel = LLEGBloodLevel - Bleed6 * LimbBleedSpeed
    end

    if LLEGBloodLevel <= 0 then
        bleed6 = false
        LLEGBloodLevel = 0
    end

    --lllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllll

    if bleed7 then
        if LLLEGBloodCapacity < MaxBloodCapacity7 / 3 then
            Bleed7 = Bleed7 * 6

            for i = 1, Bleed7 / extremeantibleed do
                smoke7()
            end
        end

        if IsBodyBroken(LLLEG) then
            for i = 1, Bleed7 / limbantibleed do
                smoke7()
            end
        end
    end

    if bleed7 then
        LLLEGBloodLevel = LLLEGBloodLevel - Bleed7 * LimbBleedSpeed
    end

    if LLLEGBloodLevel <= 0 then
        bleed7 = false
        LLLEGBloodLevel = 0
    end

    --lllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllll

    if bleed8 then
        if RLEGBloodCapacity < MaxBloodCapacity8 / 3 then
            Bleed8 = Bleed8 * 6

            for i = 1, Bleed8 / extremeantibleed do
                smoke8()
            end
        end

        if IsBodyBroken(RLEG) then
            for i = 1, Bleed8 / limbantibleed do
                smoke8()
            end
        end
    end

    if bleed8 then
        RLEGBloodLevel = RLEGBloodLevel - Bleed8 * LimbBleedSpeed
    end

    if RLEGBloodLevel <= 0 then
        bleed8 = false
        RLEGBloodLevel = 0
    end

    --lllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllll

    if bleed9 then
        if RRLEGBloodCapacity < MaxBloodCapacity9 / 3 then
            Bleed9 = Bleed9 * 6

            for i = 1, Bleed9 / extremeantibleed do
                smoke9()
            end
        end

        if IsBodyBroken(RRLEG) then
            for i = 1, Bleed9 / limbantibleed do
                smoke9()
            end
        end
    end

    if bleed9 then
        RRLEGBloodLevel = RRLEGBloodLevel - Bleed9 * LimbBleedSpeed
    end

    if RRLEGBloodLevel <= 0 then
        bleed9 = false
        RRLEGBloodLevel = 0
    end

    TotalLegBloodCapacity = MaxBloodCapacity6 + MaxBloodCapacity7 + MaxBloodCapacity8 + MaxBloodCapacity9
    TotalLegBloodValue = RRLEGBloodLevel + RLEGBloodLevel + LLLEGBloodLevel + LLEGBloodLevel

    TotalBloodValue =
        RRLEGBloodLevel + RLEGBloodLevel + LLLEGBloodLevel + LLEGBloodLevel + RRARMBloodLevel + RARMBloodLevel +
        LLARMBloodLevel +
        LARMBloodLevel +
        TorsoBloodLevel +
        HeadBloodLevel
    upspeed[2] = TotalLegBloodValue / Shock
    if IsBodyBroken(LLLEG) then
        upspeed[2] = upspeed[2] / 2
    end
    if IsBodyBroken(LRLEG) then
        upspeed[2] = upspeed[2] / 2
    end

    currentvel = GetBodyVelocity(Head)
    currentvel1 = GetBodyVelocity(LLLEG)
    currentvel2 = GetBodyVelocity(RRLEG)

    if IsBodyBroken(Head) and alive then
        alive = false
        if deathtim < maxdeathtim then
            causeofdeath = "brain damage"
        end
    end

    if not HasTag(Torso, "Zombie") then
        if TorsoBloodCapacity < MaxBloodCapacity1 / 3 or TorsoBloodLevel < MaxBloodCapacity1 / 4 and alive then
            alive = false
            if deathtim < maxdeathtim then
                causeofdeath = "organ failure"
            end
        end
    end
    if not conditioncritical or Morphine then
        if alive and not tripped then
            SetBodyVelocity(Head, VecAdd(currentvel, upspeed))
            if not IsBodyBroken(LLLEG) and not IsBodyBroken(LLEG) then
                SetBodyVelocity(LLLEG, VecAdd(currentvel1, downspeed))
            else
                Shock = Shock * 1.05
            end
            if not IsBodyBroken(RRLEG) and not IsBodyBroken(RLEG) then
                SetBodyVelocity(RRLEG, VecAdd(currentvel2, downspeed))
            else
                Shock = Shock * 1.01
            end
        end
    end

    a = GetPlayerTransform()

    distToPlayer = VecLength(VecSub(a.pos, TorsoPos.pos))

    if not started then
        startblood = TotalBloodValue
        started = true
    end

    if TotalBloodValue < startblood / 1.1 then
        conditioncritical = true
        if TotalBloodValue < startblood / 1.4 and not IsJointBroken(neck) and alive and not revived then
            alive = false
            if deathtim < maxdeathtim then
                causeofdeath = "blood loss"
            end
        end
    end

    if InputPressed("lmb") and alive then
        aboto = true
    end

    if aboto then
        pressedtim = pressedtim + dt
        if pressedtim > 1 then
            pressedtim = 0
            aboto = false
        end
    end

    if aboto and not alive then
        playerinteraction = true
    end

    if TotalBleedValue > 200 then
        if deathtim < maxdeathtim then
            causeofdeath = "Absolute body failure"
        end
        alive = false
    end

    for i = 1, #Boilers do
        Boiler = Boilers[i]
        BoilerTrans = GetBodyTransform(Boiler)
        Disttoboiler = VecLength(VecSub(HeadPos.pos, BoilerTrans.pos))
        BoilerVel = GetBodyVelocity(Boiler)
        if
            BoilerVel[2] > 1 or
                BoilerVel[2] < -1 and Disttoboiler < 5 and not alive and deathtim < 1 and not playerinteraction and
                    not aboto
         then
            if not aboto or playerinteraction or deathtim > 1 then
                --causeofdeath = "crushed by boiler"
            end
        end
    end
    switched = false
    if inrange then
        if InputPressed("h") and not switched and not pin then
			SetTag(Torso,"Stats_Pinned")
            pin = true
            switched = true
		elseif InputPressed("h") and not switched and pin then
			RemoveTag(Torso,"Stats_Pinned")
            pin = false
            switched = true
        end
    end
    drugs()

    if pin then
        inrange = true
    end

    cycledthrucode = true
end

function GetAimPos()
    local ct = GetPlayerCameraTransform()
    local forwardPos = TransformToParentPoint(ct, Vec(0, 0, -150))
    local direction = VecSub(forwardPos, ct.pos)
    local distance = VecLength(direction)
    local direction = VecNormalize(direction)
    QueryRejectBody(sb)
    local hit, hitDistance = QueryRaycast(ct.pos, direction, distance)
    if hit then
        forwardPos = TransformToParentPoint(ct, Vec(0, 0, -hitDistance))
        distance = hitDistance
    end
    return forwardPos, hit, distance
end

function round(v)
    return math.floor(v + 0.5)
end

function smoke()
    --spawn sparks
    ParticleType("smoke")
    ParticleColor(0.3, 0, 0)
    ParticleRadius(0.05, 0.005)
    ParticleAlpha(1000)
    ParticleCollide(1)
    ParticleGravity(bloodgrav)
    ParticleSticky(0.5)
    ParticleDrag(blooddrag)
    ParticleStretch(1)
    SpawnParticle(
        HeadPos.pos,
        Vec(
            math.random(-Bleed / antibleed, Bleed / antibleed),
            math.random(-Bleed / antibleed, Bleed / antibleed),
            math.random(-Bleed / antibleed, Bleed / antibleed)
        ),
        10
    )
end

function smoke1()
    --spawn sparks
    ParticleType("smoke")
    ParticleColor(0.3, 0, 0)
    ParticleRadius(0.05, 0.005)
    ParticleAlpha(1000)
    ParticleCollide(1)
    ParticleGravity(bloodgrav)
    ParticleSticky(0.5)
    ParticleDrag(blooddrag)
    ParticleStretch(1)
    SpawnParticle(
        TorsoPos.pos,
        Vec(
            math.random(-Bleed1 / antibleed, Bleed1 / antibleed),
            math.random(-Bleed1 / antibleed, Bleed1 / antibleed),
            math.random(-Bleed1 / antibleed, Bleed1 / antibleed)
        ),
        10
    )
end

function smoke2()
    --spawn sparks
    ParticleType("smoke")
    ParticleColor(0.3, 0, 0)
    ParticleRadius(0.05, 0.005)
    ParticleAlpha(1000)
    ParticleCollide(1)
    ParticleGravity(bloodgrav)
    ParticleSticky(0.5)
    ParticleDrag(blooddrag)
    ParticleStretch(1)
    SpawnParticle(
        LARMPos.pos,
        Vec(
            math.random(-Bleed2 / antibleed, Bleed2 / antibleed),
            math.random(-Bleed2 / antibleed, Bleed2 / antibleed),
            math.random(-Bleed2 / antibleed, Bleed2 / antibleed)
        ),
        10
    )
end

function smoke3()
    --spawn sparks
    ParticleType("smoke")
    ParticleColor(0.3, 0, 0)
    ParticleRadius(0.05, 0.005)
    ParticleAlpha(1000)
    ParticleCollide(1)
    ParticleGravity(bloodgrav)
    ParticleSticky(0.5)
    ParticleDrag(blooddrag)
    ParticleStretch(1)
    SpawnParticle(
        LLARMPos.pos,
        Vec(
            math.random(-Bleed3 / antibleed, Bleed3 / antibleed),
            math.random(-Bleed3 / antibleed, Bleed3 / antibleed),
            math.random(-Bleed3 / antibleed, Bleed3 / antibleed)
        ),
        10
    )
end

function smoke4()
    --spawn sparks
    ParticleType("smoke")
    ParticleColor(0.3, 0, 0)
    ParticleRadius(0.05, 0.005)
    ParticleAlpha(1000)
    ParticleCollide(1)
    ParticleGravity(bloodgrav)
    ParticleSticky(0.5)
    ParticleDrag(blooddrag)
    ParticleStretch(1)
    SpawnParticle(
        RARMPos.pos,
        Vec(
            math.random(-Bleed3 / antibleed, Bleed3 / antibleed),
            math.random(-Bleed3 / antibleed, Bleed3 / antibleed),
            math.random(-Bleed3 / antibleed, Bleed3 / antibleed)
        ),
        10
    )
end

function smoke5()
    --spawn sparks
    ParticleType("smoke")
    ParticleColor(0.3, 0, 0)
    ParticleRadius(0.05, 0.005)
    ParticleAlpha(1000)
    ParticleCollide(1)
    ParticleGravity(bloodgrav)
    ParticleSticky(0.5)
    ParticleDrag(blooddrag)
    ParticleStretch(1)
    SpawnParticle(
        RRARMPos.pos,
        Vec(
            math.random(-Bleed3 / antibleed, Bleed3 / antibleed),
            math.random(-Bleed3 / antibleed, Bleed3 / antibleed),
            math.random(-Bleed3 / antibleed, Bleed3 / antibleed)
        ),
        10
    )
end

function smoke6()
    --spawn sparks
    ParticleType("smoke")
    ParticleColor(0.3, 0, 0)
    ParticleRadius(0.05, 0.005)
    ParticleAlpha(1000)
    ParticleCollide(1)
    ParticleGravity(bloodgrav)
    ParticleSticky(0.5)
    ParticleDrag(blooddrag)
    ParticleStretch(1)
    SpawnParticle(
        LLEGPos.pos,
        Vec(
            math.random(-Bleed3 / antibleed, Bleed3 / antibleed),
            math.random(-Bleed3 / antibleed, Bleed3 / antibleed),
            math.random(-Bleed3 / antibleed, Bleed3 / antibleed)
        ),
        10
    )
end

function smoke7()
    --spawn sparks
    ParticleType("smoke")
    ParticleColor(0.3, 0, 0)
    ParticleRadius(0.05, 0.005)
    ParticleAlpha(1000)
    ParticleCollide(1)
    ParticleGravity(bloodgrav)
    ParticleSticky(0.5)
    ParticleDrag(blooddrag)
    ParticleStretch(1)
    SpawnParticle(
        LLLEGPos.pos,
        Vec(
            math.random(-Bleed3 / antibleed, Bleed3 / antibleed),
            math.random(-Bleed3 / antibleed, Bleed3 / antibleed),
            math.random(-Bleed3 / antibleed, Bleed3 / antibleed)
        ),
        10
    )
end

function smoke8()
    --spawn sparks
    ParticleType("smoke")
    ParticleColor(0.3, 0, 0)
    ParticleRadius(0.05, 0.005)
    ParticleAlpha(1000)
    ParticleCollide(1)
    ParticleGravity(bloodgrav)
    ParticleSticky(0.5)
    ParticleDrag(blooddrag)
    ParticleStretch(1)
    SpawnParticle(
        RLEGPos.pos,
        Vec(
            math.random(-Bleed3 / antibleed, Bleed3 / antibleed),
            math.random(-Bleed3 / antibleed, Bleed3 / antibleed),
            math.random(-Bleed3 / antibleed, Bleed3 / antibleed)
        ),
        10
    )
end

function smoke9()
    --spawn sparks
    ParticleType("smoke")
    ParticleColor(0.3, 0, 0)
    ParticleRadius(0.05, 0.005)
    ParticleAlpha(1000)
    ParticleCollide(1)
    ParticleGravity(bloodgrav)
    ParticleSticky(0.5)
    ParticleDrag(blooddrag)
    ParticleStretch(1)
    SpawnParticle(
        RRLEGPos.pos,
        Vec(
            math.random(-Bleed3 / antibleed, Bleed3 / antibleed),
            math.random(-Bleed3 / antibleed, Bleed3 / antibleed),
            math.random(-Bleed3 / antibleed, Bleed3 / antibleed)
        ),
        10
    )
end

function Foam()
    --spawn Foam
    ParticleType("smoke")
    ParticleColor(0.6, 0.6, 0.6)
    ParticleRadius(0.3, 0.005)
    ParticleAlpha(1000, 0)
    ParticleCollide(1)
    ParticleGravity(-16)
    ParticleSticky(0)
    ParticleDrag(0.4)
    ParticleStretch(1)
    direction = TransformToParentVec(foamtrans, Vec(0, 1, 0))
    smokeSpeed = 10
    SpawnParticle(foamtrans.pos, VecScale(direction, smokeSpeed), 10)
end

function draw(dt)
    if drawtext then
        UiPush()
        UiAlign("center middle")
        UiTranslate(400, 200)
        UiFont("bold.ttf", 30)
        UiText("Head Blood Level:  " .. HeadBloodLevel)
        UiPop()

        UiPush()
        UiAlign("center middle")
        UiTranslate(400, 220)
        UiFont("bold.ttf", 30)
        UiText("Torso Blood Level:  " .. TorsoBloodLevel)
        UiPop()

        UiPush()
        UiAlign("center middle")
        UiTranslate(400, 240)
        UiFont("bold.ttf", 30)
        UiText("upper left arm Blood Level:  " .. LARMBloodLevel)
        UiPop()

        UiPush()
        UiAlign("center middle")
        UiTranslate(400, 260)
        UiFont("bold.ttf", 30)
        UiText("Lower left arm Blood Level:  " .. LLARMBloodLevel)
        UiPop()

        UiPush()
        UiAlign("center middle")
        UiTranslate(400, 280)
        UiFont("bold.ttf", 30)
        UiText("Upper right arm Blood Level:  " .. RARMBloodLevel)
        UiPop()

        UiPush()
        UiAlign("center middle")
        UiTranslate(400, 300)
        UiFont("bold.ttf", 30)
        UiText("Lower right arm Blood Level:  " .. RRARMBloodLevel)
        UiPop()

        UiPush()
        UiAlign("center middle")
        UiTranslate(400, 320)
        UiFont("bold.ttf", 30)
        UiText("Upper left leg Blood Level:  " .. LLEGBloodLevel)
        UiPop()

        UiPush()
        UiAlign("center middle")
        UiTranslate(400, 340)
        UiFont("bold.ttf", 30)
        UiText("Lower left leg Blood Level:  " .. LLLEGBloodLevel)
        UiPop()

        UiPush()
        UiAlign("center middle")
        UiTranslate(400, 360)
        UiFont("bold.ttf", 30)
        UiText("Upper right leg Blood Level:  " .. RLEGBloodLevel)
        UiPop()

        UiPush()
        UiAlign("center middle")
        UiTranslate(400, 380)
        UiFont("bold.ttf", 30)
        UiText("Lower right leg Blood Level:  " .. RRLEGBloodLevel)
        UiPop()

        UiPush()
        UiAlign("center middle")
        UiTranslate(400, 400)
        UiFont("bold.ttf", 30)
        UiText("total Blood Level:  " .. TotalBloodValue)
        UiPop()
    end
	
    if inrange and not GetBool("game.map.enabled") then
		showInfoPanel(dt)
    end
    
    UiPop()
end

function showInfoPanel(dt)
	
	local health = round(math.max(0,100*round(TotalBloodValue) / round(MaximumBloodValue)))		
	local ox = round(math.max(0,100*math.min(1,round(oxygen) / round(lungintegrity))))		
	if not alive and enabled or not alive and inrange then	
		health = 0
	end
	
	UiPush()
		UiTranslate(UiWidth()/2-410,UiHeight()-280) -- centered panel
		--UiTranslate(30,UiHeight()-250) -- left panel
		--UiTranslate(UiWidth()-800,UiHeight()-250) -- right panel
		
		local cod = causeofdeath
		if causeofdeath ~= nil then
			cod = cod:upper()
		end
		
		local stats = {
			living= alive, 
			causeOfDeath= cod,
			playerInteraction = playerinteraction,
			deathByTripping  = deathbytripping,
			morphine = Morphine,
			adrenaline = Adrenaline,
			medkit = Medkit,
		}
		if HasTag(Torso,"FireMan") then
			drawHeartbeat(dt,name,health, ox, "MOD/imgs/fireman.PNG", stats)	
		elseif HasTag(Torso, "gender") and GetTagValue(Torso, "gender") == "male" then	
        if HasTag(Torso, "scientist") then
            drawHeartbeat(dt,name,health, ox, "MOD/imgs/scientist.PNG", stats)
        end
        if HasTag(Torso, "businessman") then
			drawHeartbeat(dt,name,health, ox, "MOD/imgs/businessman.PNG", stats)
        end	
        if HasTag(Torso, "green") then
            drawHeartbeat(dt,name,health, ox, "MOD/imgs/green.PNG", stats)
        end 
		else

        if HasTag(Torso, "maid") then
            drawHeartbeat(dt,name,health, ox, "MOD/imgs/maid.PNG", stats)
        end 
        if HasTag(Torso, "rhea") then
            drawHeartbeat(dt,name,health, ox, "MOD/imgs/rhea.PNG", stats)
        end
        if HasTag(Torso, "goth") then
            drawHeartbeat(dt,name,health, ox, "MOD/imgs/goth.PNG", stats)
        end  
        if HasTag(Torso, "punk") then
            drawHeartbeat(dt,name,health, ox, "MOD/imgs/punk.PNG", stats)
        end
		end
	UiPop()
end
	
function canSeePlayer()
    local camTrans = GetPlayerCameraTransform()
    local playerPos = camTrans.pos

    --Direction to player
    local dir = VecSub(playerPos, shootPos)
    local dist = VecLength(dir)
    dir = VecNormalize(dir)

    QueryRejectVehicle(GetPlayerVehicle())
    return not QueryRaycast(shootPos, dir, dist, 0, true)
end

function drugs()
   injectrange = 1
   --MORPHINE SYRINGE
   DurationM = 15
   SyringesM = FindShapes("morphine", true)
   for i=1,#SyringesM do
   SyringeM = SyringesM[i]
   SyringeMpos = GetShapeWorldTransform(SyringeM).pos
   DisttoSyringeM = VecLength(VecSub(TorsoPos.pos, SyringeMpos))
   if DisttoSyringeM < injectrange and InputDown("rmb") and HasTag(SyringeM, "active") then
      DruggedM = true
      onmorphine = onmorphine + DurationM
      Delete(SyringeM)
   end
   end
   --MORPHINE EFFECTS
   if DruggedM then
      if onmorphine > 30 and not revived then
         alive = false
         causeofdeath = "overdose"
      end
      if onmorphine > 0 then
         onmorphine = onmorphine - 0.001
         Morphine = true
      else
         Morphine = false
      end
   end

   --ADRENALINE SYRINGE
   DurationA = 30
    SyringesA = FindShapes("adrenaline", true)
   for i=1,#SyringesA do
   SyringeA = SyringesA[i]
   SyringeApos = GetShapeWorldTransform(SyringeA).pos
   DisttoSyringeA = VecLength(VecSub(TorsoPos.pos, SyringeApos))
   if DisttoSyringeA < injectrange and InputDown("rmb") and HasTag(SyringeA, "active") then
      DruggedA = true
      onadrenaline = onadrenaline + DurationA
      Delete(SyringeA)
   end
   end
   --ADRENALINE EFFECTS
   if DruggedA then
      trippingspeed = 15
      walkspeed = swalkspeed / 3
      if onadrenaline > 30 and not revived then
         alive = false
         causeofdeath = "overdose"
      end
      if onadrenaline > 0 then
         onadrenaline = onadrenaline - 0.001
         Adrenaline = true
         Morphine = true
      else
         Adrenaline = false
      end
   else
      walkspeed = swalkspeed
      trippingspeed = starttrippingspeed
   end

      --MEDKIT
   DurationMed = 60
    SyringesMed = FindShapes("medkit", true)
   for i=1,#SyringesMed do
   SyringeMed = SyringesMed[i]
   SyringeMedpos = GetShapeWorldTransform(SyringeMed).pos
   DisttoSyringeMed = VecLength(VecSub(TorsoPos.pos, SyringeMedpos))
   if HasTag(SyringeMed, "active") then
      Uses = tonumber(GetTagValue(SyringeMed, "uses"))
      SetTag(SyringeMed, "interact", "uses left: "..Uses)
   end
   if DisttoSyringeMed < injectrange and InputDown("rmb") and HasTag(SyringeMed, "active") and onmedkit < 1 then
      SetTag(SyringeMed, "uses", Uses - 1 )
      DruggedMed = true
      onmedkit = onmedkit + DurationMed
      if Uses < 1 then
         Delete(SyringeMed)
   end
   end
   --MEDKIT EFFECTS
   if DruggedMed then
      if onmedkit > 60 then
         onmedkit = 60
      end
      if onmedkit > 0 then
         onmedkit = onmedkit - 0.001
         Medkit = true
      else
         Medkit = false
      end
   end
end

-- DEFIBULATOR
machine = FindShape("machine",true)
defibulator1 = FindShape("defibulator1",true)
defibulator2 = FindShape("defibulator2",true)
def1trans = GetShapeWorldTransform(defibulator1)
def2trans = GetShapeWorldTransform(defibulator2)
disttodef1 = VecLength(VecSub(def1trans.pos, TorsoPos.pos))
disttodef2 = VecLength(VecSub(def2trans.pos, TorsoPos.pos))
if deathtim < 120 then
if disttodef1 < 0.6 and disttodef2 < 0.6 then
    if HasTag(defibulator1, "active") then
        reviveval = math.random(-3,3)
        RemoveTag(defibulator1, "active")
            RemoveTag(defibulator2, "active")
            PlaySound(discharge)
            if alive and reviveval == 3 then
                alive = false
                causeofdeath = "cardiac arrest"
                SetBodyVelocity(LLLEG,Vec(0,12,0))
            SetBodyVelocity(RRLEG,Vec(0,12,0))
            SetBodyVelocity(Head,Vec(0,12,0))
            end
        if not alive and reviveval == 3 then
            if causeofdeath == "smoke inhalation" or causeofdeath == "overdose" or causeofdeath == "blood loss" then
            revived = true
        alive = true
        deathtim = 0
        if oxygen < 70 then
        oxygen = 71
        lowoxygen = false
        end
            end
        else
            if alive then
                tripped = true
            end
            SetBodyVelocity(LLLEG,Vec(0,12,0))
            SetBodyVelocity(RRLEG,Vec(0,12,0))
            SetBodyVelocity(Head,Vec(0,12,0))
        end
    end
    end
end
end