function init()
	camera1 = GetLocationTransform(FindLocation("mainMenuCamera1",true))
	camera2 = GetLocationTransform(FindLocation("mainMenuCamera2",true))
	camera3 = GetLocationTransform(FindLocation("mainMenuCamera3",true))
	camera4 = GetLocationTransform(FindLocation("mainMenuCamera4",true))
	camera5 = GetLocationTransform(FindLocation("mainMenuCamera5",true))
	
	SetBool("rescue.main.menu",true)		
	
	move = 0
	cam = 0
end

function tick(dt)	
	move = move + dt*0.05
	
	if cam == 0 then SetCameraTransform(Transform(VecAdd(camera1.pos, {move,0,0}), camera1.rot)) end
	if cam == 1 then SetCameraTransform(Transform(VecAdd(camera2.pos, {move,0,0}), camera2.rot)) end
	if cam == 2 then SetCameraTransform(Transform(VecAdd(camera3.pos, {move,0,0}), camera3.rot)) end
	if cam == 3 then SetCameraTransform(Transform(VecAdd(camera4.pos, {move,0,0}), camera4.rot)) end
	if cam == 4 then SetCameraTransform(Transform(VecAdd(camera5.pos, {move,0,0}), camera5.rot)) end
	
	if move > 0.6 then
		cam = (cam + 1) % 5
		move = 0	
	end
end

function draw()
	UiMakeInteractive()

	UiPush()
		UiTranslate(UiWidth()/2-500,UiHeight()/5)
		UiImageBox("MOD/imgs/title.png",1000,120,10,10)
	UiPop()
	
	UiPush()
		UiTranslate(UiWidth()/2-170,UiHeight()/2)
		UiColor(0,0,0,0.8)
		UiRect(340,100)		
		UiFont("regular.ttf",100)
		UiColor(1,1,1)
		UiTranslate(40,80)
		if UiTextButton("P L A Y") then
			DebugPrint(1)
			StartLevel("level1", "MOD/level_choice.xml")
		end
	UiPop()
end