function init()  
    light = FindLight("night")
    trigger = FindTrigger("light")
    out = false
    outTime = 0
end

function tick(dt)    
    PlayerPos = GetPlayerPos()
    TriggerPos = GetTriggerTransform(trigger).pos
    outTime = outTime - dt
    
    if outTime < 0 then
        outTime = 0
    end    
    
    if outTime > 0 then 
        if out then
            SetLightEnabled(light, true)
        else
            SetLightEnabled(light, true)
        end
    else
            SetLightEnabled(light, false)
    end

    if IsPointInTrigger(trigger, PlayerPos) then
        if not out and outTime <= 0 then
            outTime = 20
            out = true
        elseif out and outTime <= 20 then
            outTime = 20
            out = true
        end
    end
end