function init()
	dishwasher = FindShape("dish")
    wireplug = FindShape("wireplug")
	cable = FindJoint("cable")
	plugbox = FindTrigger("plugbox")
	dishLight = FindLight("dish")
	lightOn = false
end

function tick(dt)
	broken1 = IsShapeBroken(dishwasher)
	broken2 = IsJointBroken(cable)
	
	if not broken1 or broken2 then
		if GetPlayerInteractShape() == dishwasher and InputPressed("interact") then
		    if IsShapeInTrigger(plugbox, wireplug) then
			    if not lightOn then
				    lightOn = true
			    else
				    lightOn = false
			    end
			end
		end
		if IsShapeInTrigger(plugbox, wireplug) then	
		    if not lightOn then
			    SetTag(dishwasher, "interact", "Turn on")
			    SetLightEnabled(dishLight, false)
       		else
 			    SetTag(dishwasher, "interact", "Turn off")
			    SetLightEnabled(dishLight, true)	
			end
		else
		    if lightOn then
			    RemoveTag(dishwasher, "interact")
			    SetLightEnabled(dishLight, false)
			    lightOn = false
			else
			    RemoveTag(dishwasher, "interact")
			    SetLightEnabled(dishLight, false)
			    lightOn = false
			end
		end
	end
	if broken1 or broken2 then
	    if lightOn then
		    RemoveTag(dishwasher, "interact")
			SetLightEnabled(dishLight, false)
			lightOn = false
	    else
		    RemoveTag(dishwasher, "interact")
			SetLightEnabled(dishLight, false)
			lightOn = false
	    end
    end
end