function init()
	masterswitch = FindShape("masterswitch")
	overrideswitch = FindShape("override")
	allLights = FindLights("light")
end

function tick(dt)
	master = GetBool("level.master1")
	override = GetBool("level.override1")
	broken = IsShapeBroken(masterswitch)
	
	
	if GetPlayerInteractShape() == masterswitch and InputPressed("interact") then
		if not master then SetBool("level.master1", true) else SetBool("level.master1", false) end
	end
	if GetPlayerInteractShape() == overrideswitch and InputPressed("interact") then
		if not override then SetBool("level.override1", true) else SetBool("level.override1", false) end
	end
	
	if override then
		SetTag(overrideswitch, "interact", "Disable Master Switch Control")
		if not master then
			SetTag(masterswitch, "interact", "Turn on all lights")
		else
			SetTag(masterswitch, "interact", "Turn off all lights")
		end
	else
		SetTag(overrideswitch, "interact", "Enable Master Switch Control")
		RemoveTag(masterswitch, "interact")
	end
end

