function init()
	pc = FindShape("pc")
	pcscreen = FindShape("pcscreen")
	screen = FindScreen("screen")
    wireplug = FindShape("wireplug")
	screencable = FindJoint("screencable")
    pccable = FindJoint("pccable")
	plugbox = FindTrigger("plugbox")
	pcscreenLight = FindLight("pcscreen")
	pcLight = FindLight("pc")
	pcOn = false
	screenOn = false
end

function tick(dt)
	broken1 = IsShapeBroken(pc)
	broken2 = IsShapeBroken(pcscreen)
	broken3 = IsJointBroken(screencable)
	broken4 = IsJointBroken(pccable)
	
	if not broken1 or broken2 or broken3 or broken4 then
		if GetPlayerInteractShape() == pc and InputPressed("interact") then
		    if IsShapeInTrigger(plugbox, wireplug) then
	            if not pcOn then
			        pcOn = true
			    else
				    pcOn = false
			    end
			end  
		end
		if GetPlayerInteractShape() == pc and InputPressed("interact") then
		    if IsShapeInTrigger(plugbox, wireplug) then
	            if not screenOn then
		    	    SetScreenEnabled(screen, true)
			        screenOn = true
			    else
				    SetScreenEnabled(screen, false)
				    screenOn = false
			    end
			end  
		end
		    if IsShapeInTrigger(plugbox, wireplug) then
		        if not pcOn then
			        SetTag(pc, "interact", "PC on")
			        SetLightEnabled(pcscreenLight, false)
			        SetLightEnabled(pcLight, false)
		        else
			        SetTag(pc, "interact", "PC off")
			        SetLightEnabled(pcscreenLight, true)
			        SetLightEnabled(pcLight, true)
		        end
            else
			    if pcOn then
			        SetLightEnabled(pcscreenLight, false)	
			        SetLightEnabled(pcLight, false)	
                    RemoveTag(pc, "interact")	
				    pcOn = false
				    SetScreenEnabled(screen, false)
				else
			        SetLightEnabled(pcscreenLight, false)	
			        SetLightEnabled(pcLight, false)	
                    RemoveTag(pc, "interact")	
					pcOn = false
				end
            end	
    end			
	if broken1 then
		if IsShapeInTrigger(plugbox, wireplug) or not IsShapeInTrigger(plugbox, wireplug) then
		    if pcOn then
			    SetLightEnabled(pcscreenLight, false)
			    SetLightEnabled(pcLight, false)	
                RemoveTag(pc, "interact")	
		        pcOn = false
			    SetScreenEnabled(screen, false)
			else
			    SetLightEnabled(pcscreenLight, false)
			    SetLightEnabled(pcLight, false)	
                RemoveTag(pc, "interact")	
		        pcOn = false
			
		    end
	    end
	end
	if broken2 then
		if IsShapeInTrigger(plugbox, wireplug) or not IsShapeInTrigger(plugbox, wireplug) then
		    if pcOn then
			    SetLightEnabled(pcscreenLight, false)
			    SetScreenEnabled(screen, false)
			    SetLightEnabled(pcLight, true)	
			else
			    SetLightEnabled(pcscreenLight, false)		
			    SetScreenEnabled(screen, false)				
		    end
	    end
	end
	if broken3 then
		if IsShapeInTrigger(plugbox, wireplug) then
		    if screenOn then
			    SetLightEnabled(pcscreenLight, false)
			    SetScreenEnabled(screen, false)
				screenOn = false
			else
			    SetLightEnabled(pcscreenLight, false)
				screenOn = false
			
		    end
	    end
	end
	if broken4 then
		if IsShapeInTrigger(plugbox, wireplug) or not IsShapeInTrigger(plugbox, wireplug) then
		    if pcOn then
			    SetLightEnabled(pcscreenLight, false)
			    SetLightEnabled(pcLight, false)	
                RemoveTag(pc, "interact")	
		        pcOn = false
			    SetScreenEnabled(screen, false)
			else
			    SetLightEnabled(pcscreenLight, false)
			    SetLightEnabled(pcLight, false)	
                RemoveTag(pc, "interact")	
		        pcOn = false
			
		    end
	    end
	end

end