function init()
	printer = FindShape("print")
    wireplug = FindShape("wireplug")
	cable = FindJoint("cable")
	plugbox = FindTrigger("plugbox")
	printLight = FindLight("print")
	printing = false
end

function tick(dt)
	broken = IsShapeBroken(printer)
	broken2 = IsJointBroken(cable)
	
	if not broken1 or broken2 then
		if GetPlayerInteractShape() == printer and InputPressed("interact") then
		    if IsShapeInTrigger(plugbox, wireplug) then
			    if not printing then
				    printing = true
			    else
				    printing = false
			    end
			end
		end
		if IsShapeInTrigger(plugbox, wireplug) then			
		    if not printing then
			    SetTag(printer, "interact", "Turn on")
			    SetLightEnabled(printLight, false)
            else
			    SetTag(printer, "interact", "Turn off")
			    SetLightEnabled(printLight, true)	
			end
		else
		    if printing then
			    RemoveTag(printer, "interact")
			    SetLightEnabled(printLight, false)
			else
			    RemoveTag(printer, "interact")
			    SetLightEnabled(printLight, false)
			end	
		end
	end
	if broken1 or broken2 then
	    if printing then
		    RemoveTag(printer, "interact")
	        SetLightEnabled(printLight, false)
		else
		    RemoveTag(printer, "interact")
	        SetLightEnabled(printLight, false)
		end
	end
end