function init()
	hydrant = FindJoint("hydrant")
	Hydro = FindShape("hydro")
	Original = GetShapeWorldTransform(Hydro)
	timer = 0
	range = 1
	trigger = FindTrigger("hydrant")
end
function tick(dt)
	HydroTrans = GetShapeWorldTransform(Hydro)
	change = VecLength(VecSub(HydroTrans.pos, Original.pos))
	if timer > 35 then
		SetTriggerTransform(trigger, Transform(Vec(0,-1000,0), QuatEuler(0,0,0)))
	end
	if change > 0.6 and timer < 35 then
		SetTriggerTransform(trigger, Original)
		newpos = Vec(Original.pos[1], Original.pos[2] - 0.7, Original.pos[3])
		Delete(hydrant)
		Foam()
		timer = timer + dt
		mi = Vec(Original.pos[1] -range, Original.pos[2]-range, Original.pos[3] -range)
		ma = Vec(Original.pos[1] +range, Original.pos[2]+range*5, Original.pos[3] +range)
		local bodies = QueryAabbBodies(mi, ma)
		for i=1,#bodies do
			Body = bodies[i]
			bodypos = GetBodyTransform(Body).pos
			ApplyBodyImpulse(Body, bodypos, Vec(0,50,0))
		end
	end
end

function Foam()
--spawn Foam
ParticleType("smoke")
ParticleColor(0.8, 0.8, 0.8)
ParticleRadius(0.3, 1)
ParticleAlpha(1000,0)
ParticleCollide(1)
ParticleGravity(-16)
ParticleSticky(0)
ParticleDrag(0.4)
ParticleStretch(1)
smokeSpeed = 30
SpawnParticle(newpos, VecScale(Vec(0,1,0), smokeSpeed), 5)
end
