function init()
	Dead = 0
	Alive = 100		
	
	firemanInfoBarTopDistance = 0
	civilianInfoBarRightDistance = 400
	StartVox = 0
	v = 0
end
function round(v)
    return math.floor(v+0.5)
end
function update()

	Brieks = FindShapes("briek", true)

	if not diddit then
		for i=1,#Brieks do
		Briek = Brieks[i]
		voxelCounts = GetShapeVoxelCount(Briek)
		StartVox = StartVox + voxelCounts
	end
	diddit = true
end
	CurrentVox = 0
	for i=1,#Brieks do
		Briek = Brieks[i]
		voxelCount = GetShapeVoxelCount(Briek)
		CurrentVox = CurrentVox + voxelCount
	end
	--DebugPrint(round(CurrentVox*100/StartVox))

	Ragdolls = FindBodies("Civillian", true)
	FireMans = FindBodies("FireMan", true)

	Alive = 0
	Dead = 0
	for i=1,#Ragdolls do
		Ragdoll = Ragdolls[i]
		if not HasTag(Ragdoll, "Dead") then
			Alive = Alive + 1
		end
	end
	for i=1,#FireMans do
		FireMan = FireMans[i]
		if not HasTag(FireMan, "Dead") then
			Alive = Alive - 1
		end
	end
	Dead = #FindBodies("Dead", true)
	if not set then
		MaxAlive = Alive
		set = true
	end
	-- Saved is how many ragdolls were extracted via ambulance
	Saved = MaxAlive - (Alive + Dead)

	-- makes mission end once theres nobody left to save
	if Alive == 0 then
		missionend = true
	end
	if missionend and InputPressed("J") then
		StartLevel("levelmainmenu","MOD/main.xml")
	end
end


function drawCivilianHealthBars()
	
	UiPush()		
		UiTranslate(civilianInfoBarRightDistance,0)
			
		UiPush()		
			UiTranslate(UiWidth()-290, 100)
			UiColor(0,0,0,0.75)
			UiImageBox("ui/common/box-solid-6.png",300,40, 10, 10)	
			UiColor(1,1,1)
			UiFont("regular.ttf", 30)	
			UiTranslate(15,30)			
			UiText("Known Civilians")
		UiPop()
		for i=1,#Ragdolls do
			Ragdoll = Ragdolls[i]
			local alive = true
			if HasTag(Ragdoll, "Dead") then
				alive = false
			end
			UiPush()		
				UiTranslate(UiWidth()-150, 130+i*45)
				UiColor(1,1,1,0.75)
				UiImageBox("ui/common/box-solid-6.png",150,40, 10, 10)	
				UiColor(1,1,1)
				UiFont("regular.ttf", 12)				
				UiPush()
					if HasTag(Ragdoll,"Stats_MaxHealth") and  HasTag(Ragdoll,"Stats_Health") then					
						UiTranslate(5,5)
						UiImageBox("MOD/imgs/greenCross.PNG",20,20,2,2)
						UiTranslate(25,5)
						UiColor(0.6,0.6,0.6)					
						UiRect(100,10)
											
						local health = 100*tonumber(GetTagValue(Ragdoll,"Stats_Health"))/tonumber(GetTagValue(Ragdoll,"Stats_MaxHealth"))
						UiColor((100-health)/100,0.5*(health/100),0)
						UiRect(health,10)
					else
						UiText("-???-")
					end			
				UiPop()
				UiPush()
					if HasTag(Ragdoll,"Stats_Oxygen") then
						UiTranslate(7,20)
						UiImageBox("MOD/imgs/O2.PNG",18,18,2,2)
						UiTranslate(23,5)
						UiColor(0.6,0.6,0.6)					
						UiRect(100,10)
											
						local oxygen = math.min(100,100*tonumber(GetTagValue(Ragdoll,"Stats_Oxygen"))/100)
						UiColor((100-oxygen)/10,0,0.5*(oxygen/100))
						UiRect(oxygen,10)
					else
						UiText("-???-")
					end
				UiPop()
			UiPop()
		end
	UiPop()
end

function drawFiremanHealthBars()

		if missionend then
		if Dead < MaxAlive/2 then
	    UiPush()
        UiAlign("center middle")
        UiTranslate(400, 200)
        UiFont("bold.ttf", 30)
        UiText("Mission Passed!!! Press J to return to main menu")
        UiTranslate(0, 40)
        UiFont("bold.ttf", 30)
        UiText("You saved "..Saved.." people")
        UiTranslate(0, 40)
        UiFont("bold.ttf", 30)
        UiText("You let "..Dead.." people die")
        UiTranslate(0, 40)
        UiFont("bold.ttf", 30)
        UiText(round(CurrentVox*100/StartVox).."% of the house was left intact")
        UiPop()
    	end

    	if Dead > MaxAlive/2 then
    		UiPush()
        UiAlign("center middle")
        UiTranslate(400, 200)
        UiFont("bold.ttf", 30)
        UiText("Mission Failed!!! Press J to return to main menu")
        UiTranslate(0, 40)
        UiFont("bold.ttf", 30)
        UiText("You saved "..Saved.." people")
        UiTranslate(0, 40)
        UiFont("bold.ttf", 30)
        UiText("You let "..Dead.." people die")
         UiTranslate(0, 40)
         UiFont("bold.ttf", 30)
        UiText(round(CurrentVox*100/StartVox).."% of the house was left intact")
        UiPop()
    	end

	end

	UiPush()
		UiTranslate(0, firemanInfoBarTopDistance) 
		local pinned = 0		
		for i=1,#FireMans do
			Ragdoll = FireMans[i]
			if HasTag(Ragdoll,"Stats_Pinned") then
				pinned = pinned + 1
				local alive = true
				if HasTag(Ragdoll, "Dead") then
					alive = false
				end	
				UiPush()	
					UiPush()		
						UiTranslate(25, 130+pinned*165-115)						
						UiImageBox("MOD/imgs/fireman.PNG",100,100, 10, 10)	
						if not alive then
							UiPush()
								UiColor(1,0,0,0.4)
								UiRect(110,110)
								UiFont("bold.ttf", 130)	
								UiTranslate(5,95)
								UiScale(1.5)
								UiRotate(10)
								UiText("X")
							UiPop()
						end
						UiTranslate(-25, 100)
						UiColor(1,1,1,1)
						UiImageBox("ui/common/box-solid-6.png",150,20, 10, 10)	
						UiColor(0,0,0)
						UiFont("bold.ttf", 14)	
						UiTranslate(10, 15)				
						UiText(GetTagValue(Ragdoll,"Stats_Name"))
					UiPop()										

					if alive then					
						UiTranslate(0, 130+pinned*165)
						UiColor(1,1,1,0.75)
						UiImageBox("ui/common/box-solid-6.png",150,40, 10, 10)	
						UiColor(1,1,1)
						UiFont("regular.ttf", 12)	
						UiPush()
							if HasTag(Ragdoll,"Stats_MaxHealth") and  HasTag(Ragdoll,"Stats_Health") then					
								UiTranslate(5,5)
								UiImageBox("MOD/imgs/greenCross.PNG",20,20,2,2)
								UiTranslate(25,5)
								UiColor(0.6,0.6,0.6)					
								UiRect(100,10)
													
								local health = 100*tonumber(GetTagValue(Ragdoll,"Stats_Health"))/tonumber(GetTagValue(Ragdoll,"Stats_MaxHealth"))
								if not alive then health = 0 end
								UiColor((100-health)/100,0.5*(health/100),0)
								UiRect(health,10)
							else
								UiText("-???-")
							end			
						UiPop()
						UiPush()
							if HasTag(Ragdoll,"Stats_Oxygen") then
								UiTranslate(7,20)
								UiImageBox("MOD/imgs/O2.PNG",18,18,2,2)
								UiTranslate(23,5)
								UiColor(0.6,0.6,0.6)					
								UiRect(100,10)					
								local oxygen = math.min(100,100*tonumber(GetTagValue(Ragdoll,"Stats_Oxygen"))/100)
								if not alive then oxygen = 0 end					
								UiColor((100-oxygen)/10,0,0.5*(oxygen/100))
								UiRect(oxygen,10)
							else
								UiText("-???-")
							end
						UiPop()
					end
				UiPop()
			end
		end
		if pinned > 0 and firemanInfoBarTopDistance < 80 then
			UiPush()		
				UiTranslate(-10, 100)
				UiColor(0,0,0,0.75)
				UiImageBox("ui/common/box-solid-6.png",300,40, 10, 10)	
				UiColor(1,1,1)
				UiFont("regular.ttf", 30)	
				UiTranslate(180,30)			
				UiText("Firemen")
			UiPop()
		end
	UiPop()
end

function draw()	
	
	UiPush()		
		UiTranslate(UiWidth()-300, 0)
		UiScale(0.5)
		UiPush()					
			UiColor(0,0,0,1)
			UiImageBox("ui/common/box-solid-6.png",550,100, 6, 6)				
		UiPop()
		
		UiPush()		
			UiTranslate(250-180, 10)
			UiImageBox("MOD/imgs/greenCross.PNG",80,80,10,10)
			UiTranslate(95, 55)
			UiFont("bold.ttf", 56)
			UiColor(0,0.6,0)
			UiText(Alive)
		UiPop()
		UiPush()		
			UiTranslate(250+80, 10)
			UiImageBox("MOD/imgs/skull.PNG",80,80,10,10)
			UiTranslate(95, 55)
			UiFont("bold.ttf", 56)
			UiColor(1,1,1)
			UiText(Dead)
		UiPop()
	UiPop()
	
	
	
	if GetBool("game.map.enabled") then 	
		if firemanInfoBarTopDistance == 0 then
			SetValue("firemanInfoBarTopDistance", 80, "easeout", 0.4)
			SetValue("civilianInfoBarRightDistance", 0, "easeout", 0.4)			
		end		
		
		for i=1,#Ragdolls do
			Ragdoll = Ragdolls[i]
			local x,y, dist = UiWorldToPixel(GetBodyTransform(Ragdoll).pos)
			UiPush()
				UiTranslate(x,y)
				if HasTag(Ragdoll,"FireMan") then
					UiColor(1,0,0)
				end
				UiImage("ui/hud/dot-small.png")
			UiPop()
		end
		
		
	elseif firemanInfoBarTopDistance == 80 then
		SetValue("firemanInfoBarTopDistance", 0, "easein", 0.4)
		SetValue("civilianInfoBarRightDistance", 400, "easein", 0.4)
	end
	--drawCivilianHealthBars()
	drawFiremanHealthBars()
end