function init()
	cap = FindShape("cap")
	caps = FindShapes("cap")
	model = FindShape("model")

	if #FindShapes("morphine") > 0 then
	morphine = FindShape("morphine")
	SetTag(morphine, "interact", "activate morphine")
	SyrM = true
	end

	if #FindShapes("adrenaline") > 0 then
	adrenaline = FindShape("adrenaline")
	SetTag(adrenaline, "interact", "activate adrenaline")
	SyrA = true
	end

	if #FindShapes("medkit") > 0 then
	medkit = FindShape("medkit")
	SetTag(medkit, "interact", "activate medkit")
	SyrMed = true
	end

	if #FindShapes("machine") > 0 then
	machine = FindShape("machine")
	SetTag(machine, "interact", "revive")
	electim = 0
	charge = LoadSound("MOD/snd/defcharge.ogg")
	SyrDef = true
	end
end
function tick(dt)
	if SyrM then
	if #FindShapes("morphine") < 1 and #FindShapes("adrenaline") < 1 and #FindShapes("medkit") < 1 then
		Delete(model)
	end
	-- Morphine (Movement while in critical condition)
	if GetPlayerInteractShape() == morphine and InputPressed("interact") then
		SetTag(morphine, "active")
		RemoveTag(morphine, "interact")
		for i=1,#caps do
			cap = caps[i]
		Delete(cap) 
		end
		
	end
	if #FindShapes("cap") < 1 then
		DrawShapeOutline(morphine, 0, 0, 1, 1)
	end
end

	-- Adrenaline (Morphine effects + Speed + Ignores oxygen levels unless they are below 0 in which case death occours + Majorly increased blood loss)
	if SyrA then
	if GetPlayerInteractShape() == adrenaline and InputPressed("interact") then
		SetTag(adrenaline, "active")
		RemoveTag(adrenaline, "interact")
		Delete(cap)
	end
	if #FindShapes("cap") < 1 then
		DrawShapeOutline(adrenaline, 1, 0, 0, 1)
	end

		-- Medkit (Instantly stops blood loss)
end

	-- Defibulator, can revive patients with minor injuries

	if SyrDef then
		if electim > 1 then
			SetTag(defibulator1, "active")
			SetTag(defibulator2, "active")
			electim = 0
			dotim = false
		end

		if GetPlayerInteractShape() == machine and InputPressed("interact") and not HasTag(defibulator1, "active") then
			defibulator1 = FindShape("defibulator1")
			defibulator2 = FindShape("defibulator2")
			dotim = true
			PlaySound(charge)
		end

		if dotim then
		electim = electim + dt
		end
end
		if SyrMed then
		if GetPlayerInteractShape() == medkit and InputPressed("interact") and not stopthecap then
		SetTag(medkit, "active")
		RemoveTag(medkit, "interact")
		stopthecap = true
		Delete(cap)
		end
		if #FindShapes("cap") < 1 and #FindShapes("medkit") > 0 then
			model = FindShape("model")
			Uses = tonumber(GetTagValue(medkit, "uses"))
			hitboxes = FindShapes("hitbox")
			if Uses < 1 then
				Delete(model)
					for i=1,#hitboxes do
					Delete(hitboxes[i])
					end
				Delete(medkit)
			end
			DrawShapeOutline(model, 1, 0, 0, 1)
		end
	end
end