function init()
	microwave = FindShape("micro")
	microLight = FindLight("micro")
    wireplug = FindShape("wireplug")
	cable = FindJoint("cable")
	plugbox = FindTrigger("plugbox")
	microplate	= FindJoint("microPlate",true)
	lightON = false
end

function tick(dt)
	broken1 = IsShapeBroken(microwave)
	broken2 = IsJointBroken(cable)
	
	if not broken1 or broken2 then
		if GetPlayerInteractShape() == microwave and InputPressed("interact") then
		    if IsShapeInTrigger(plugbox, wireplug) then
			    if not turning then
				    turning = true
			    else
				    turning = false
			    end
			end
		end
		if IsShapeInTrigger(plugbox, wireplug) then		
		    if not turning then
			    SetTag(microwave, "interact", "Turn on")
			    SetLightEnabled(microLight, false)
			    SetJointMotor(microplate, 0.0)
		    else
			    SetTag(microwave, "interact", "Turn off")
			    SetLightEnabled(microLight, true)	
			    SetJointMotor(microplate, 1.5)
			end
		else
		    if turning then
  		        RemoveTag(microwave, "interact")
			    SetLightEnabled(microLight, false)
			    SetJointMotor(microplate, 0.0)
			else
  		        RemoveTag(microwave, "interact")
			    SetLightEnabled(microLight, false)
			    SetJointMotor(microplate, 0.0)
			end
			
		end
	end
	if broken1 or broken2 then
	    if turning then
		    RemoveTag(microwave, "interact")
	        SetJointMotor(microplate, 0.0)
		    SetLightEnabled(microLight, false)
		else
		    RemoveTag(microwave, "interact")
	        SetJointMotor(microplate, 0.0)
		    SetLightEnabled(microLight, false)
		end
	end

end