function init()
	ovenbox = FindShape("oven")
	wireplug = FindShape("wireplug")
	cable = FindJoint("cable")
	plugbox = FindTrigger("plugbox")
	ovenLight = FindLight("ovenlight")
	lightON = false
end

function tick(dt)
	broken1 = IsShapeBroken(ovenbox)
	broken2 = IsJointBroken(cable)
	
	if not broken1 or broken2 then
		if GetPlayerInteractShape() == ovenbox and InputPressed("interact") then
		    if IsShapeInTrigger(plugbox, wireplug) then
			    if not lightON then
				    lightON = true
			    else
				    lightON = false
			    end
			end
		end
		
		if IsShapeInTrigger(plugbox, wireplug) then		
		    if not lightON then
			    SetTag(ovenbox, "interact", "Turn on")
			    SetLightEnabled(ovenLight, false)

		    else
			    SetTag(ovenbox, "interact", "Turn off")
			    SetLightEnabled(ovenLight, true)	
		
		    end
	    else
		    if lightON then
			    SetLightEnabled(ovenLight, false)
				RemoveTag(ovenbox, "interact")
				lightON = false
			else
			    SetLightEnabled(ovenLight, false)
				RemoveTag(ovenbox, "interact")
				lightON = false
			end
		end
	end
	if broken1 or broken2 then
	    if lightON then
		    RemoveTag(ovenbox, "interact")
			SetLightEnabled(ovenLight, false)
			lightON = false
		else
		    RemoveTag(ovenbox, "interact")
			SetLightEnabled(ovenLight, false)
			lightON = false
		end
	end
end