function init()
	washingmachine = FindShape("washing")
	washingLight = FindLight("washing")
    wireplug = FindShape("wireplug")
	cable = FindJoint("cable")
	plugbox = FindTrigger("plugbox")
	washingdrum = FindJoint("drum",true)
	lightOn	= false
end

function tick(dt)
	broken1 = IsShapeBroken(washingmachine)
	broken2 = IsJointBroken(cable)
	
	if not broken1 or broken2 then
		if GetPlayerInteractShape() == washingmachine and InputPressed("interact") then
		    if IsShapeInTrigger(plugbox, wireplug) then
			    if not turning then
				    turning = true
	                lightOn = true
			    else
				    turning = false
	                lightOn = false
			    end
			end
		end
		if IsShapeInTrigger(plugbox, wireplug) then		
		    if not turning then
			    SetTag(washingmachine, "interact", "Turn on")
			    SetLightEnabled(washingLight, false)
			    SetJointMotor(washingdrum, 0)
            else
			    SetTag(washingmachine, "interact", "Turn off")
			    SetLightEnabled(washingLight, true)	
			    SetJointMotor(washingdrum, 15.5)
			end
		else 
		    if lightOn then 
			    RemoveTag(washingmachine, "interact")
			    SetLightEnabled(washingLight, false)
			    SetJointMotor(washingdrum, 0)
			else
			    RemoveTag(washingmachine, "interact")
			    SetLightEnabled(washingLight, false)
			    SetJointMotor(washingdrum, 0)
			end
		end
	end
	if broken1 or broken2 then
	    if lightOn then
		    RemoveTag(washingmachine, "interact")
			SetLightEnabled(washingLight, false)
	        SetJointMotor(washingdrum, 0)
		else
		    RemoveTag(washingmachine, "interact")
			SetLightEnabled(washingLight, false)
	        SetJointMotor(washingdrum, 0)
		end
	end

end